{open Parser;; open Lexing;;
exception Lexical_error ;; exception End_of_file;;
}
rule terminal = parse
  | [' ''\t']  		{terminal lexbuf}
  | '\r'?'\n' 
      {lexbuf.lex_curr_p <-
	 {lexbuf.lex_curr_p with pos_lnum =lexbuf.lex_curr_p.pos_lnum+1;
	   pos_bol =lexbuf.lex_curr_p.pos_cnum

	 }; 
       terminal lexbuf}
	 
  | '('		{LPAR}
  | ')'		{RPAR}
  | "=>"		{IMP}
  | "<=>"		{EQU}
  | "."		{AND}
  | "+"		{OR}
  | "-"		{NOT}
  | "F"         {FALSE}
  | ";;"		{END}
  | "quit"	{QUIT}
  | "valid"	{VALID}
  | "syntax"  {SYNTAX}
  | "help"    {HELP}
  | "let"		{LET}
  | "="		{EGAL}
  |  ['a'-'z''A'-'Z']['a'-'z''A'-'Z''0'-'9''_']*	 	
			{VAR (lexeme lexbuf)} 
  |  ['A'-'Z']['a'-'z''A'-'Z''0'-'9''_']*  
			{ABREV (lexeme lexbuf)}
  | _		{raise Lexical_error}
      
{ }
